diff -ur slackware64-current.2/source/d/gcc/gcc.SlackBuild slackware64-current.3/source/d/gcc/gcc.SlackBuild
--- slackware64-current.2/source/d/gcc/gcc.SlackBuild	2024-08-30 05:19:51.000606322 +0200
+++ slackware64-current.3/source/d/gcc/gcc.SlackBuild	2025-06-21 22:16:40.745911309 +0200
@@ -69,7 +69,7 @@
 
 # Which compilers do we want to build?
 if [ -z $LANGS ]; then
-  LANGS="ada,c,c++,d,fortran,go,lto,m2,objc,obj-c++,rust"
+  LANGS="c,c++,fortran,lto,m2,objc,obj-c++"
   # Add COBOL on supported $ARCH:
   if [ "$(uname -m)" = "x86_64" -o "$(uname -m)" = "aarch64" ]; then
     LANGS="${LANGS},cobol"
@@ -99,10 +99,10 @@
 # Try to figure out if we want multilib (or set MULTILIB= manually).
 # BTW, --disable-multilib is only ever used on x86_64.
 # Using it elsewhere will break the build.
-if [ "$ARCH" = "x86_64" -a ! -L /lib/ld-linux.so.2 ]; then
-  MULTILIB=${MULTILIB:-"--disable-multilib"}
-else
+if [ "$ARCH" = "x86_64" -a -L /lib/ld-linux.so.2 ]; then
   MULTILIB=${MULTILIB:-"--enable-multilib"}
+else
+  MULTILIB=${MULTILIB:-"--disable-multilib"}
 fi
 
 # If the variable PRINT_PACKAGE_NAME is set, then this script will report what
@@ -143,6 +143,28 @@
     *)    TARGET=$ARCH-slackware-linux ;;
 esac
 
+addlang=""
+if [ "$ARCH" != "hppa" -a "$ARCH" != "or1k" -a "$ARCH" != "loongarch64" -a "$ARCH" != "sh4" ]; then
+  # libgo not support syscall for hppa, or1k, and loongarch64. On sh4 "Unhandled trap 0x180".
+  addlang="go,"
+fi
+
+which gnat 2> /dev/null 
+if [ $? -eq 0 ] ; then
+  addlang="${addlang}ada,"
+fi
+
+which gdc 2> /dev/null 
+if [ $? -eq 0 ] ; then
+  addlang="${addlang}d,"
+fi
+
+which cargo 2> /dev/null 
+if [ $? -eq 0 -a "$ARCH" != "s390x" ] ; then
+  # segment violation while building librust on s390x...
+  addlang="${addlang}rust,"
+fi
+
 # Temporary build location:
 TMP=${TMP:-/tmp}
 
@@ -196,6 +203,23 @@
   fi
 done
 
+if [ "$ARCH" = "arm" -o "$ARCH" = "sparc" ]
+then
+  # Ada tools now requires 64 bits atomic operation, need to link atomic library for arm and sparc:
+  zcat $CWD/patches/gcc.ada.atomic.armdiff.gz | patch -p1 --verbose || exit 1
+fi
+
+if [ `gcc -dM -E - < /dev/null | grep -c LP64.*1` -eq 0 ]
+then
+  # Fix ada time_t bits:
+  cp gcc/ada/libgnat/s-parame__posix2008.ads  gcc/ada/libgnat/s-parame.ads
+fi
+
+# Disabling c++ double128 compatibility on PowerPC platform
+#sed -i  's/powerpc\*-\*-linux\*/xpowerpc/' libstdc++-v3/configure
+# Disabling c++ double128 compatibility on Sparc(32bit) platform
+#sed -i  's/sparc\*-\*-linux\*/sparc64-*-linux*/' gcc-$VERSION/libstdc++-v3/configure
+
 # Fix perms/owners:
 chown -R root:root .
 find . \
@@ -374,21 +398,37 @@
 ( mkdir gcc.build.lnx
   cd gcc.build.lnx
 
-  if [ "$ARCH" = "x86_64" ]; then
-    GCC_ARCHOPTS="--with-arch=x86-64"
-  else
+  if [ "$ARCH" == "armv7hl" ]; then
+    GCC_ARCHOPTS="--with-tune=cortex-a8 --with-arch=armv7-a --with-float=hard --with-fpu=vfpv3-d16 --with-abi=aapcs-linux"
+  elif [ "$ARCH" == "arm" ]; then
+    GCC_ARCHOPTS="--with-arch=armv5te --with-float=soft"
+  elif [ "$ARCH" == "aarch64" ]; then
+    GCC_ARCHOPTS="--with-arch=armv8-a"
+  elif [ "$ARCH" == "mips" ]; then
+    GCC_ARCHOPTS="--with-arch=mips32r2"
+  elif [ "$ARCH" == "mipsel" ]; then
+    GCC_ARCHOPTS="--with-arch=mips32r2"
+  elif [ "$ARCH" == "mips64el" ]; then
+    GCC_ARCHOPTS="--with-arch=mips64r2"
+  elif [ "$ARCH" == "sparc" ]; then
+    GCC_ARCHOPTS="--with-cpu=leon3 --with-float=hard --disable-libitm"
+  elif [ "$ARCH" == "sparc64" ]; then
+    GCC_ARCHOPTS="--with-cpu=ultrasparc --with-float=hard"
+  elif [ `echo "$ARCH" | grep -cE '^i.86$'` -gt 0 ]; then
     GCC_ARCHOPTS="--with-arch=$ARCH"
   fi
  
-  CFLAGS="$SLKCFLAGS" \
-  CXXFLAGS="$SLKCFLAGS" \
+  CFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS_DISABLED" \
+  CXXFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS_DISABLED" \
+  LDFLAGS="-Wl,--no-keep-memory -Wl,--reduce-memory-overheads" \
+  BOOT_LDFLAGS="-Wl,--no-keep-memory -Wl,--reduce-memory-overheads" \
   ../configure --prefix=/usr \
      --libdir=/usr/lib$LIBDIRSUFFIX \
      --mandir=/usr/man \
      --infodir=/usr/info \
      --enable-shared \
      --enable-bootstrap \
-     --enable-languages=${LANGS} \
+     --enable-languages=${addlang}${LANGS} \
      --enable-threads=posix \
      --enable-checking=release \
      --with-system-zlib \
@@ -421,6 +461,7 @@
   # Include all debugging info (for now):
   make $NUMJOBS bootstrap || exit 1
 
+  if [ `echo $addlang | grep -c 'ada,'` -gt 0 ] ; then
   ( cd gcc
     make $NUMJOBS gnatlib GNATLIBCFLAGS="$SLKCFLAGS" || exit 1
     # This wants a shared -ladd2line?
@@ -430,6 +471,7 @@
     CXXFLAGS="$SLKCFLAGS" \
     make $NUMJOBS gnattools || exit 1
   ) || exit 1
+  fi
   make info || exit 1
 
   # Set GCCCHECK=something to run the tests
@@ -439,6 +481,11 @@
 
   make install DESTDIR=$PKG1 || exit 1
 
+  if [ -d "$PKG1/usr/lib$LIBDIRSUFFIX/"'!m4' ]
+  then
+    (cd "$PKG1/usr/lib$LIBDIRSUFFIX/"'!m4' ; mv * .. ; cd .. ; rmdir '!m4')
+  fi
+
   # Move gdb pretty printers to the correct place
   mkdir -p $PKG1/usr/share/gdb/auto-load/usr/lib$LIBDIRSUFFIX
   mv $PKG1/usr/lib$LIBDIRSUFFIX/*-gdb.py \
@@ -451,7 +498,7 @@
 
   # Make our 64bit gcc look for 32bit gcc binaries in ./32 subdirectory.
   # This is needed only for x86_64 + --disable-multilib.
-  if [ "$ARCH" = "x86_64" -a "$MULTILIB" = "--disable-multilib" ]; then
+  if [ "$LIBDIRSUFFIX" = "64" -a "$MULTILIB" = "--disable-multilib" ]; then
     sed -i 's#;.\(:../lib !m64 m32;\)$#;32\1#' \
       $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/${TARGET}/${VERSION}/specs
   fi
@@ -499,6 +546,15 @@
     cat $CWD/c89.sh > c89
     cat $CWD/c99.sh > c99
     chmod 755 c89 c99
+    if [ "$TARGET" != "${ARCH}-slackware-linux" ]
+    then
+      for b in gm2 c++ g++ cc gcc gcc-ar gcc-nm gcc-ranlib gccgo gdc gfortran
+      do
+	if [ -f $b ]; then
+     	  ln -s $b ${ARCH}-slackware-linux-$b
+	fi
+      done
+    fi
   )
 
   ( cd $PKG1/usr/man
@@ -564,7 +620,7 @@
     mkdir -p usr/lib
     mv $PKG1/usr/lib/*++* usr/lib
   fi
-)
+) || exit 1
 
 # gcc-gfortran:
 ( cd $PKG3
@@ -594,8 +650,9 @@
     mv $PKG1/usr/lib/gcc/$TARGET/$VERSION/finclude usr/lib/gcc/$TARGET/$VERSION
     mv $PKG1/usr/lib/gcc/$TARGET/$VERSION/libgfortran* usr/lib/gcc/$TARGET/$VERSION
   fi
-)
+) || exit 1
 
+if [ `echo $addlang | grep -c 'ada,'` -gt 0 ] ; then
 # gcc-gnat:
 ( cd $PKG4
   mkdir -p usr/bin
@@ -617,7 +674,8 @@
     mv $PKG1/usr/lib64/gcc/$TARGET/$VERSION/32/adalib usr/lib/gcc/$TARGET/$VERSION
     ln -sf /usr/lib/gcc/$TARGET/$VERSION/adalib usr/lib64/gcc/$TARGET/$VERSION/32/adalib
   fi
-)
+) || exit 1
+fi
 
 # gcc-objc:
 ( cd $PKG6
@@ -625,7 +683,6 @@
   mv $PKG1/usr/libexec/gcc/$TARGET/$VERSION/cc1obj usr/libexec/gcc/$TARGET/$VERSION
   mv $PKG1/usr/libexec/gcc/$TARGET/$VERSION/cc1objplus usr/libexec/gcc/$TARGET/$VERSION
   mkdir -p usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include
-  mv $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include/objc usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include
   mv $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include/cc1objplus usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include
   # Libraries:
   # As a rule, we don't package static libraries.
@@ -638,8 +695,11 @@
     mkdir -p usr/lib
     mv $PKG1/usr/lib/libobjc* usr/lib
   fi
-)
+  # Move this at the end to be sure it exists and will not generate error
+  mv $PKG1/usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include/objc usr/lib${LIBDIRSUFFIX}/gcc/$TARGET/$VERSION/include
+) || exit 1
 
+if [ `echo $addlang | grep -c 'go,'` -gt 0 ] ; then
 # gcc-go:
 ( cd $PKG8
   mkdir -p usr/bin
@@ -667,7 +727,9 @@
     rm -f $PKG1/usr/lib/libgo.a
   fi
 ) || exit 1
+fi
 
+if [ `echo $addlang | grep -c 'd,'` -gt 0 ] ; then
 # gcc-gdc:
 ( cd $PKG10
   mkdir -p usr/bin
@@ -704,6 +766,7 @@
     #rm -f usr/lib/libgdruntime.a
   fi
 )
+fi
 
 # gcc-gm2:
 ( cd $PKG11
@@ -738,6 +801,7 @@
   fi
 )
 
+if [ `echo $addlang | grep -c 'rust,'` -gt 0 ] ; then
 # gcc-rust:
 ( cd $PKG12
   mkdir -p usr/bin
@@ -745,6 +809,7 @@
   mkdir -p usr/libexec/gcc/$TARGET/$VERSION
   mv $PKG1/usr/libexec/gcc/$TARGET/$VERSION/crab1 usr/libexec/gcc/$TARGET/$VERSION
 ) || exit 1
+fi
 
 # gcc-cobol:
 if echo $LANGS | grep -q cobol ; then
@@ -771,18 +836,26 @@
   makepkg -l y -c n $TMP/gcc-g++-${VERSION}${VERTAG}-$ARCH-${BUILD}${TAG}.txz )
 ( cd $PKG3
   makepkg -l y -c n $TMP/gcc-gfortran-${VERSION}${VERTAG}-$ARCH-${BUILD}${TAG}.txz )
+if [ `echo $addlang | grep -c 'ada,'` -gt 0 ] ; then
 ( cd $PKG4
   makepkg -l y -c n $TMP/gcc-gnat-${VERSION}${VERTAG}-$ARCH-${BUILD}${TAG}.txz )
+fi
 ( cd $PKG6
   makepkg -l y -c n $TMP/gcc-objc-${VERSION}${VERTAG}-$ARCH-${BUILD}${TAG}.txz )
+if [ `echo $addlang | grep -c 'go,'` -gt 0 ] ; then
 ( cd $PKG8
   makepkg -l y -c n $TMP/gcc-go-${VERSION}${VERTAG}-$ARCH-${BUILD}${TAG}.txz )
+fi
+if [ `echo $addlang | grep -c 'd,'` -gt 0 ] ; then
 ( cd $PKG10
   makepkg -l y -c n $TMP/gcc-gdc-${VERSION}${VERTAG}-$ARCH-${BUILD}${TAG}.txz )
+fi
 ( cd $PKG11
   makepkg -l y -c n $TMP/gcc-gm2-${VERSION}${VERTAG}-$ARCH-${BUILD}${TAG}.txz )
+if [ `echo $addlang | grep -c 'rust,'` -gt 0 ] ; then
 ( cd $PKG12
   makepkg -l y -c n $TMP/gcc-rust-${VERSION}${VERTAG}-$ARCH-${BUILD}${TAG}.txz )
+fi
 if echo $LANGS | grep -q cobol ; then
   ( cd $PKG13
     makepkg -l y -c n $TMP/gcc-gcobol-${VERSION}${VERTAG}-$ARCH-${BUILD}${TAG}.txz )
diff -ur slackware64-current.2/source/d/gdb/gdb.SlackBuild slackware64-current.3/source/d/gdb/gdb.SlackBuild
--- slackware64-current.2/source/d/gdb/gdb.SlackBuild	2025-01-07 13:26:22.986572044 +0100
+++ slackware64-current.3/source/d/gdb/gdb.SlackBuild	2025-01-07 13:31:20.532487765 +0100
@@ -73,6 +73,11 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" ] ; then
+  # Avoid overflow on simulator for MIPS32:
+  zcat $CWD/mips32_overflow.diff.gz | patch -p1 --verbose || exit 1
+fi
+
 # This has been perpetually broken, so we'll default to turning it off:
 GUILE_OPTION=${GUILE_OPTION:-"--without-guile"}
 
diff -ur slackware64-current.2/source/d/gettext-tools/gettext-tools.SlackBuild slackware64-current.3/source/d/gettext-tools/gettext-tools.SlackBuild
--- slackware64-current.2/source/d/gettext-tools/gettext-tools.SlackBuild	2025-05-14 21:58:46.434661672 +0200
+++ slackware64-current.3/source/d/gettext-tools/gettext-tools.SlackBuild	2025-05-19 11:01:33.762814404 +0200
@@ -67,6 +67,15 @@
 # Don't use icecream:
 PATH=$(echo $PATH | sed "s|/usr/libexec/icecc/bin||g" | tr -s : | sed "s/^://g" | sed "s/:$//g")
 
+if [ "$ARCH" = "armv7hl" -o "${ARCH::3}" = "ppc" -o "$ARCH" = "or1k" -o "$ARCH" ]
+then
+  # Some architectures do not have a fully working d compiler:
+  # - armv7hl, or1k: "d21: error: cannot find source code for runtime library file 'object.d'"
+  # - ppc*: gnu/libintl/libintl.d:35:8: error: unable to read module 'conv'
+  #         gnu/libintl/libintl.d:35:8: note: Expected 'std/conv.d' or 'std/conv/package.d' 
+  EXTRACONF="--disable-d"
+fi
+
 rm -rf $PKG
 mkdir -p $TMP $PKG
 cd $TMP
@@ -90,6 +99,7 @@
   --infodir=/usr/info \
   --mandir=/usr/man \
   --docdir=/usr/doc/gettext-tools-$VERSION \
+  $EXTRACONF \
   --build=$ARCH-slackware-linux || exit 1
 
 make $NUMJOBS || make || exit 1
diff -ur slackware64-current.2/source/d/guile/guile.SlackBuild slackware64-current.3/source/d/guile/guile.SlackBuild
--- slackware64-current.2/source/d/guile/guile.SlackBuild	2021-04-28 20:11:00.493022067 +0200
+++ slackware64-current.3/source/d/guile/guile.SlackBuild	2021-09-18 13:42:53.586930953 +0200
@@ -73,6 +73,9 @@
 tar xvf $CWD/guile-$VERSION.tar.?z || exit 1
 cd guile-$VERSION || exit 1
 
+# Remove 32-bit-big-endian prebuilt, since it does not work:
+rm -rf prebuilt/32-bit-big-endian
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -90,6 +93,7 @@
   --disable-static \
   --disable-rpath \
   --disable-error-on-warning \
+  $EXTRAGUILE \
   --build=$ARCH-slackware-linux || exit 1
 
 # Does not like parallel make...
diff -ur slackware64-current.2/source/d/libgccjit/libgccjit.SlackBuild slackware64-current.3/source/d/libgccjit/libgccjit.SlackBuild
--- slackware64-current.2/source/d/libgccjit/libgccjit.SlackBuild	2024-02-13 22:27:32.208514310 +0100
+++ slackware64-current.3/source/d/libgccjit/libgccjit.SlackBuild.new	2024-02-13 23:36:51.525931524 +0100
@@ -150,7 +149,23 @@
 ( mkdir gcc.build.lnx
   cd gcc.build.lnx
 
-  if [ "$ARCH" != "x86_64" ]; then
+  if [ "$ARCH" == "armv7hl" ]; then
+    GCC_ARCHOPTS="--with-tune=cortex-a8 --with-arch=armv7-a --with-float=hard --with-fpu=vfpv3-d16 --with-abi=aapcs-linux"
+  elif [ "$ARCH" == "arm" ]; then
+    GCC_ARCHOPTS="--with-arch=armv5te --with-float=soft"
+  elif [ "$ARCH" == "aarch64" ]; then
+    GCC_ARCHOPTS="--with-arch=armv8-a"
+  elif [ "$ARCH" == "mips" ]; then
+    GCC_ARCHOPTS="--with-arch=mips32r2"
+  elif [ "$ARCH" == "mipsel" ]; then
+    GCC_ARCHOPTS="--with-arch=mips32r2"
+  elif [ "$ARCH" == "mips64el" ]; then
+    GCC_ARCHOPTS="--with-arch=mips64r2 --disable-multilib"
+  elif [ "$ARCH" == "sparc" ]; then
+    GCC_ARCHOPTS="--with-cpu=leon3 --with-float=hard --disable-multilib --disable-libitm"
+  elif [ "$ARCH" == "sparc64" ]; then
+    GCC_ARCHOPTS="--with-cpu=ultrasparc --with-float=hard --disable-multilib"
+  elif [ `echo "$ARCH" | grep -cE '^i.86$'` -gt 0 ]; then
     GCC_ARCHOPTS="--with-arch=$ARCH"
   else
     GCC_ARCHOPTS="--disable-multilib"
diff -ur slackware64-current.2/source/d/llvm/llvm.SlackBuild slackware64-current.3/source/d/llvm/llvm.SlackBuild
--- slackware64-current.2/source/d/llvm/llvm.SlackBuild	2024-06-20 23:25:05.566400028 +0200
+++ slackware64-current.3/source/d/llvm/llvm.SlackBuild	2024-07-03 01:34:21.643239525 +0200
@@ -33,23 +33,12 @@
 
 if [ -z "$ARCH" ]; then
   case "$( uname -m )" in
-    i?86) ARCH=i686 ;;
+    i?86) ARCH=i586 ;;
     arm*) ARCH=arm ;;
        *) ARCH=$( uname -m ) ;;
   esac
 fi
 
-# Select projects to build:
-if [ "$ARCH" = "i586" -o "$ARCH" = "i686" ]; then
-  # bolt and flang are not available on 32-bit
-  LLVM_ENABLE_PROJECTS=${LLVM_ENABLE_PROJECTS:-"clang;clang-tools-extra;compiler-rt;lld;lldb;llvm;mlir;openmp;polly"}
-else
-  LLVM_ENABLE_PROJECTS=${LLVM_ENABLE_PROJECTS:-"bolt;clang;clang-tools-extra;compiler-rt;flang;lld;lldb;llvm;mlir;openmp;polly"}
-fi
-
-# Select runtimes to build:
-LLVM_ENABLE_RUNTIMES=${LLVM_ENABLE_RUNTIMES:-"libcxx;libcxxabi"}
-
 # If the variable PRINT_PACKAGE_NAME is set, then this script will report what
 # the name of the created package would be, and then exit. This information
 # could be useful to other scripts.
@@ -66,6 +55,8 @@
 # massive warning spew:
 IGNORE_GNU_EXTENSIONS=${IGNORE_GNU_EXTENSIONS:--Wno-unknown-warning-option -Wno-gnu-line-marker -Wno-gnu-anonymous-struct -Wno-gnu-include-next}
 
+LINKER="lld"
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686 $IGNORE_GNU_EXTENSIONS"
   LIBDIRSUFFIX=""
@@ -80,6 +71,104 @@
   LIBDIRSUFFIX=""
 fi
 
+# Building lld will be determined automatically unless BUILD_LLD is
+# preset to YES or NO:
+if [ -z $BUILD_LLD ]; then
+  if [ "$ARCH" =  "or1k" -o "$ARCH" = "sh4" -o "$ARCH" = "alpha" -o "$ARCH" = "hppa" ]; then
+    BUILD_LLD=NO
+  else
+    BUILD_LLD=YES
+  fi
+fi
+
+# Building lldb will be determined automatically unless BUILD_LLDB is
+# preset to YES or NO:
+if [ -z $BUILD_LLDB ]; then
+  if [ "$ARCH" = "riscv64" -o "$ARCH" = "ppc" -o "${ARCH::4}" = "mips"  -o "$ARCH" =  "or1k" -o "$ARCH" = "sh4" -o "$ARCH" = "alpha" -o "$ARCH" = "hppa" -o "${ARCH::5}" = "sparc" ]; then
+    BUILD_LLDB=NO
+  else
+    BUILD_LLDB=YES
+  fi
+fi
+
+# Building OpenMP will be determined automatically unless BUILD_OPENMP is
+# preset to YES or NO:
+if [ -z $BUILD_OPENMP ]; then
+  if [ "$ARCH" = "ppc" -o "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "riscv64" -o "$ARCH" = "s390x" -o "$ARCH" =  "or1k" -o "$ARCH" = "sh4" -o "$ARCH" = "alpha" -o "$ARCH" = "hppa" -o "${ARCH::5}" = "sparc" ]; then
+    # OpenMP not supported on PowerPC 32 bits / RISC-V / zArchitecture
+    BUILD_OPENMP=NO
+  else
+    BUILD_OPENMP=YES
+  fi
+fi
+
+# Building Host clang will be determined automatically unless BUILD_HOST is
+# preset to YES or NO:
+if [ -z $BUILD_HOST ]; then
+  if [ "$ARCH" = "sh4" -o "$ARCH" = "or1k" -o "$ARCH" = "hppa" -o "$ARCH" = "alpha" ]; then
+    # clang not supported on sh4, or1k, hppa, alpha
+    BUILD_HOST=NO
+  else
+    BUILD_HOST=YES
+  fi
+fi
+
+if [ -z $BUILD_BOLT ]; then
+  if [ "$ARCH" = "x86_64" -o "$ARCH" = "aarch64" ]; then
+    BUILD_BOLT=YES
+  else
+    BUILD_BOLT=NO
+  fi
+fi
+
+if [ -z $BUILD_FLANG ]; then
+  if [ `gcc -dM -E - < /dev/null | grep -c __LP64__` -eq 0 -o "$BUILD_HOST" = "NO" ]; then
+    # flang not supported on 32-bit CPUs
+    BUILD_FLANG=NO
+  else
+    if [ "$ARCH" = "mips64el" -o "$ARCH" = "s390x" ]; then
+      BUILD_FLANG=NO
+    else
+      BUILD_FLANG=YES
+    fi
+  fi
+fi
+
+
+LLVM_ENABLE_PROJECTS="llvm;mlir"
+
+if [ "$BUILD_HOST" = "YES" ]; then
+  ADD_HOST="host;"
+  # Select projects to build:
+  LLVM_ENABLE_PROJECTS="${LLVM_ENABLE_PROJECTS};compiler-rt;clang;clang-tools-extra;polly"
+  # Select runtimes to build:
+  LLVM_ENABLE_RUNTIMES=${LLVM_ENABLE_RUNTIMES:-"libcxx;libcxxabi"}
+else
+  ADD_HOST=""
+  # Select projects to build:
+  LLVM_ENABLE_PROJECTS="${LLVM_ENABLE_PROJECTS};clang"
+fi
+
+if [ "$BUILD_LLD" = "YES" ]; then
+  LLVM_ENABLE_PROJECTS="${LLVM_ENABLE_PROJECTS};lld"
+fi
+
+if [ "$BUILD_LLDB" = "YES" ]; then
+  LLVM_ENABLE_PROJECTS="${LLVM_ENABLE_PROJECTS};lldb"
+fi
+
+if [ "$BUILD_OPENMP" = "YES" ]; then
+  LLVM_ENABLE_PROJECTS="${LLVM_ENABLE_PROJECTS};openmp"
+fi
+
+if [ "$BUILD_BOLT" = "YES" ]; then
+  LLVM_ENABLE_PROJECTS="${LLVM_ENABLE_PROJECTS};bolt"
+fi
+
+if [ "$BUILD_FLANG" = "YES" ]; then
+  LLVM_ENABLE_PROJECTS="${LLVM_ENABLE_PROJECTS};flang"
+fi
+
 # Python3 short version:
 PY3=$(python3 -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())' | cut -f 2 -d n | cut -f 1 -d /)
 
@@ -100,6 +182,42 @@
 # Support GCC built for i?86-slackware-linux:
 zcat $CWD/clang.toolchains.32-bit.triple.diff.gz | patch -p2 --verbose || exit 1
 
+# Patch arm: soft float, invalid conversion from unwind state:
+zcat $CWD/arm_soft.diff.gz | patch -p1 --verbose || exit 1
+zcat $CWD/unwind_state_invalid_conversion.diff.gz | patch -p1 --verbose || exit 1
+
+if [ "${ARCH::3}" = "arm" ]; then
+  # Re-enabling system libunwind, since it searches for aeabi_unwind* function that are
+  # not present in bundled one
+  zcat $CWD/arm_enable_system_libunwind.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" ]; then
+  # Disabling FLOAT16, since it requires mips64 instructions
+  zcat $CWD/mips_disable_float16.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+if [ "$BUILD_HOST" = "NO" ]; then
+  # Disabling arch/triple autodetection, since it does not work without host target
+  zcat $CWD/disable_default_arch_detect.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+# Patch riscv64: AllWinner D1 does not have fence.tso instruction:
+zcat $CWD/riscv64-no-fence.tso.diff.gz | patch -p1 --verbose || exit 1
+
+# Patch alpha: Fix invalid variable name __alpha:
+zcat $CWD/alpha_fix_variable_name.diff.gz | patch -p1 --verbose || exit 1
+
+# Add new architectures (loongarch64, or1k, etc...) to cmake config.guess and config-ix.cmake:
+\cp /usr/share/libtool/build-aux/config.* llvm/cmake/
+zcat $CWD/newarchs.diff.gz | patch -p1 --verbose || exit 1
+
+# Fix incorrect sanitizer data structures for enabled 64bit time_t on 32bit architectures:
+zcat $CWD/sanitizer_time64.diff.gz | patch -p1 --verbose || exit 1
+
+# Fix failing test on mips 32 bit with comparison of long with int:
+zcat $CWD/interception_test_disable_mips.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -107,11 +220,26 @@
   \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# In bootstrap system, or for architectures that does not support host llvm,
+# clang is not yet available or it could not compile c(++) sources, use gcc
+which clang 2> /dev/null
+if [ $? -eq 0 -a `file -L $(which clang) | grep -c 'shell script'` -eq 0 ]
+then
+  C_COMPILER="clang"
+  CXX_COMPILER="clang++"
+else
+  C_COMPILER="gcc"
+  CXX_COMPILER="g++"
+  LINKER="bfd"
+fi
+
+SLKCFLAGS="$SLKCFLAGS $IGNORE_GNU_EXTENSIONS"
+
 mkdir build
 cd build
   cmake -GNinja \
-    -DCMAKE_C_COMPILER="clang" \
-    -DCMAKE_CXX_COMPILER="clang++" \
+    -DCMAKE_C_COMPILER="$C_COMPILER" \
+    -DCMAKE_CXX_COMPILER="$CXX_COMPILER" \
     -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
     -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
     -DCMAKE_INSTALL_PREFIX=/usr \
@@ -120,7 +248,7 @@
     -DLLVM_BUILD_LLVM_DYLIB=ON \
     -DLLVM_LINK_LLVM_DYLIB=ON \
     -DCLANG_LINK_CLANG_DYLIB=ON \
-    -DLLVM_USE_LINKER=lld \
+    -DLLVM_USE_LINKER=$LINKER \
     -DLLVM_ENABLE_PROJECTS="$LLVM_ENABLE_PROJECTS" \
     -DLLVM_ENABLE_RUNTIMES="$LLVM_ENABLE_RUNTIMES" \
     -DLLVM_ENABLE_RTTI=ON \
@@ -131,7 +259,8 @@
     -DLLVM_INSTALL_UTILS=ON \
     -DLLVM_BINUTILS_INCDIR=/usr/include \
     -DCLANG_RESOURCE_DIR="../lib${LIBDIRSUFFIX}/clang/$(echo $VERSION | cut -f 1 -d .)" \
-    -DLLVM_TARGETS_TO_BUILD="host;AMDGPU;BPF;WebAssembly" \
+    -DLLVM_TARGETS_TO_BUILD="${ADD_HOST}AMDGPU;BPF;WebAssembly" \
+    $CMAKE_EXTRA \
     -DLLVM_INCLUDE_BENCHMARKS=OFF \
     -DCOMPILER_RT_BUILD_LIBFUZZER=OFF \
     -DCLANG_DEFAULT_PIE_ON_LINUX=ON \
@@ -145,11 +274,28 @@
   DESTDIR=$PKG "$NINJA" install || exit 1
 cd ..
 
+case "$ARCH" in
+  arm) TARGET=$ARCH-slackware-linux-gnueabi ;;
+  armv7hl) TARGET=$ARCH-slackware-linux-gnueabihf ;;
+  mips64el) TARGET=$ARCH-slackware-linux-gnueabi64 ;;
+     *) TARGET=$ARCH-slackware-linux ;;
+esac
+
 # Add symlinks for $ARCH-slackware-linux-{clang,clang++}:
 ( cd $PKG/usr/bin
-  ln -sf clang $ARCH-slackware-linux-clang
-  ln -sf clang++ $ARCH-slackware-linux-clang++
+  ln -sf clang $TARGET-clang
+  ln -sf clang++ $TARGET-clang++
+)
+
+# Add clang target if host clang not built:
+if [ "$BUILD_HOST" = "NO" ]; then
+( cd $PKG/usr/bin
+  SHORTVER=`echo clang-[0-9][0-9] | sed 's/clang-//'`
+  mv clang-$SHORTVER clang-$SHORTVER.orig
+  cat $CWD/clang.target | sed "s/-XX/-$SHORTVER/g" > clang-$SHORTVER
+  chmod 755 clang-$SHORTVER
 )
+fi
 
 # Install clang-static-analyzer:
 for i in ccc c++; do
diff -ur slackware64-current.2/source/d/m4/m4.SlackBuild slackware64-current.3/source/d/m4/m4.SlackBuild
--- slackware64-current.2/source/d/m4/m4.SlackBuild	2021-05-31 21:24:21.170031455 +0200
+++ slackware64-current.3/source/d/m4/m4.SlackBuild	2023-06-15 09:15:36.667957641 +0200
@@ -81,6 +81,9 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Disabled SPARCv8plus instructions (-mcpu=v9):
+sed -i 's/ -mcpu=v9//' configure
+
 CFLAGS="$SLKCFLAGS" \
 ./configure \
   --prefix=/usr \
diff -ur slackware64-current.2/source/d/meson/meson.SlackBuild slackware64-current.3/source/d/meson/meson.SlackBuild
--- slackware64-current.2/source/d/meson/meson.SlackBuild	2021-06-08 22:36:48.082202988 +0200
+++ slackware64-current.3/source/d/meson/meson.SlackBuild	2021-09-18 13:42:53.796941553 +0200
@@ -65,6 +65,16 @@
  \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
   -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \+
 
+# Meson check only if the compiler supports NEON instructions without
+# checking if CAN compile NEON instructions with selected architecture.
+# Disabling simd-neon for ARMv5 ("arm" ARCH):
+if [ "$ARCH" = "arm" ]; then
+  zcat $CWD/disabling_neon_armv5.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+# Adding new architectures (openrisc):
+zcat $CWD/new_architectures.diff.gz | patch -p1 --verbose || exit 1
+
 python3 setup.py install --root=$PKG || exit 1
 
 mv $PKG/usr/share/man $PKG/usr/
diff -ur slackware64-current.2/source/d/oprofile/oprofile.SlackBuild slackware64-current.3/source/d/oprofile/oprofile.SlackBuild
--- slackware64-current.2/source/d/oprofile/oprofile.SlackBuild	2021-08-28 21:45:51.897177190 +0200
+++ slackware64-current.3/source/d/oprofile/oprofile.SlackBuild	2021-09-18 13:42:53.846944077 +0200
@@ -82,6 +82,11 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Disabling PFMLIB for powerpc platform:
+zcat $CWD/disable_pfm.patch.gz | patch -p1 --verbose || exit 1
+# Adding rmb definition for riscv:
+zcat $CWD/riscv_rmb_definition.diff.gz | patch -p1 --verbose || exit 1
+
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
 ./configure \
diff -ur slackware64-current.2/source/d/perl/perl.SlackBuild slackware64-current.3/source/d/perl/perl.SlackBuild
--- slackware64-current.2/source/d/perl/perl.SlackBuild	2021-05-21 06:51:21.743866987 +0200
+++ slackware64-current.3/source/d/perl/perl.SlackBuild	2025-08-06 10:26:43.536998375 +0200
@@ -146,7 +146,7 @@
 #
 USE_THREADS="-Dusethreads -Duseithreads"
 
-if [ "$ARCH" = "x86_64" ]; then # adopted from "Cross Linux From Scratch"
+if [ "$LIBDIRSUFFIX" = "64" ]; then # adopted from "Cross Linux From Scratch"
   # Configure must be told to also use lib64:
   zcat $CWD/perl.configure.multilib.patch.gz | patch -p1 --verbose || exit 1
   # "perl -V" should report that libc is in /lib64
@@ -181,6 +181,7 @@
   -Dsitelib="/usr/local/share/perl5" \
   -Dsitearch="/usr/local/lib${LIBDIRSUFFIX}/perl5" \
   -Darchlib="/usr/lib${LIBDIRSUFFIX}/perl5" \
+  -Duse64bitint \
   -Dvendorprefix=/usr \
   -Dprivlib="/usr/share/perl5" \
   -Dvendorlib="/usr/share/perl5/vendor_perl" \
diff -ur slackware64-current.2/source/d/poke/poke.SlackBuild slackware64-current.3/source/d/poke/poke.SlackBuild
--- slackware64-current.2/source/d/poke/poke.SlackBuild	2022-01-31 09:45:37.918393279 +0100
+++ slackware64-current.3/source/d/poke/poke.SlackBuild	2023-07-07 15:32:31.178365617 +0200
@@ -86,6 +86,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Disable v9-assembly for sparc32:
+zcat $CWD/jitter_disable_assembly_for_sparc32.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/d/python2/python2.SlackBuild slackware64-current.3/source/d/python2/python2.SlackBuild
--- slackware64-current.2/source/d/python2/python2.SlackBuild	2021-02-13 06:31:55.408945438 +0100
+++ slackware64-current.3/source/d/python2/python2.SlackBuild	2021-09-18 13:42:54.126958210 +0200
@@ -81,12 +81,15 @@
 # We don't want a large libpython*.a:
 zcat $CWD/python.no-static-library.diff.gz | patch -p1 --verbose || exit 1
 
-if [ "$ARCH" = "x86_64" ]; then
+if [ "$LIBDIRSUFFIX" = "64" ]; then
   # Install to lib64 instead of lib and 
   # Python must report /usr/lib64/python2.7/site-packages as python_lib_dir:
   zcat $CWD/python.x86_64.diff.gz | patch -p1 --verbose || exit 1
 fi
 
+# Add _ctypes support for MIPS64
+zcat $CWD/python.mips64-missing-n32-functions.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
